import java.util.*;
import java.lang.*;

/** This is a template for an HMM class.  Fill in code for the
 * constructor and all of the methods.
 */
public class Hmm {

    /** Constructs an HMM class with <tt>numStates</tt> possible
     * states and <tt>numOutputs</tt> possible outputs.
     */
    public Hmm(int numStates, int numOutputs) {
	// your code here
    }

    /** Builds an HMM from the given set of state and output
     * sequences.  Here, <tt>state[i][j]</tt> is the <tt>j</tt>-th
     * element of the <tt>i</tt>-th state sequence, and similarly for
     * <tt>output[i][j]</tt>.
     */
    public void buildFromData(int state[][], int output[][]) {
	// your code here
    }

    /** Returns the most likely state sequence for the given
     * <tt>output</tt> sequence, i.e., the state sequence of highest
     * conditional probability, according to this HMM, given the
     * output sequence.  The returned state sequence should have the
     * same number of elements as the given output sequence.
     */
    public int[] mostLikelySequence(int output[]) {
	// your code here
    }

    /** Returns the probability assigned by this HMM to a transition
     * from the dummy start state to the given <tt>state</tt>.
     */
    public double getStartProb(int state) {
	// your code here
    }

    /** Returns the probability assigned by this HMM to a transition
     * from <tt>fromState</tt> to <tt>toState</tt>.
     */
    public double getTransProb(int fromState, int toState) {
	// your code here
    }

    /** Returns the probability of <tt>state</tt> emitting
     * <tt>output</tt>.
     */
    public double getOutputProb(int state, int output) {
	// your code here
    }

    /** Builds an HMM from the given tables of probabilities.
     *
     *  @param startProb an array of <tt>numStates</tt> numbers
     *                   where <tt>startProb[i]</tt> represents the
     *                   probability of moving from the dummy start
     *                   state to state <tt>i</tt>
     *  @param transProb a matrix of <tt>numStates</tt> x <tt>numStates</tt>
     *                   numbers where <tt>transProb[i][j]</tt>
     *                   represents the probability of moving from
     *                   state <tt>i</tt> to state <tt>j</tt>
     *  @param outputProb a matrix of <tt>numStates</tt> x <tt>numOutputs</tt>
     *                   numbers where <tt>outputProb[i][j]</tt>
     *                   represents the probability of emitting output
     *                   <tt>j</tt> in state <tt>i</tt>
     */
    public void buildFromTable(double startProb[],
			       double transProb[][],
			       double outputProb[][]) {
	// your code here
    }

}
